function getCurrentTabUrl(callback) {
    var queryInfo = {
        active: true, currentWindow: true
    };

    chrome.tabs.query(queryInfo, function(tabs) {
        var tab = tabs[0] || {};

        callback(tab);
    });
}

var prefix = "js_", position = 0, popovers = [];

var oib = {
    baseDomain: "https://ops-in-a-box.com/", currentUrl: "", setLoggedUser: function(a) {
        localStorage.setItem("loggedUser", a);
        return this;
    }, getLoggedUser: function() {
        return localStorage.getItem("loggedUser");
    }, setPage: function(a) {
        localStorage.setItem("page", a);
        return this;
    }, getPage: function() {
        return localStorage.getItem("page");
    }, getCurrentSession: function() {
        return localStorage.getItem("currentSession");
    }, setCurrentSession: function(a) {
        localStorage.setItem("currentSession", a);
        return this;
    }, getLastSession: function() {
        return localStorage.getItem("lastSession");
    }, setLastSession: function(a) {
        localStorage.setItem("lastSession", a);
        return this;
    }, getCurrentSessionTitle: function() {
        return localStorage.getItem("currentSessionTitle");
    }, setCurrentSessionTitle: function(a) {
        localStorage.setItem("currentSessionTitle", a);
        return this;
    }, isModifiedTitle: function() {
        return localStorage.getItem("ModifiedTitle");
    }, setModifiedTitle: function(a) {
        localStorage.setItem("ModifiedTitle", a);
        return this;
    }, uniqueID: function() {
        return prefix + (position++).toString(36);
    }, removeDiacritics: function(str) {
        var defaultDiacriticsRemovalMap = [{'base': 'A', 'letters': /[\u0041\u24B6\uFF21\u00C0\u00C1\u00C2\u1EA6\u1EA4\u1EAA\u1EA8\u00C3\u0100\u0102\u1EB0\u1EAE\u1EB4\u1EB2\u0226\u01E0\u00C4\u01DE\u1EA2\u00C5\u01FA\u01CD\u0200\u0202\u1EA0\u1EAC\u1EB6\u1E00\u0104\u023A\u2C6F]/g}, {'base': 'AA', 'letters': /[\uA732]/g}, {'base': 'AE', 'letters': /[\u00C6\u01FC\u01E2]/g}, {'base': 'AO', 'letters': /[\uA734]/g}, {'base': 'AU', 'letters': /[\uA736]/g}, {'base': 'AV', 'letters': /[\uA738\uA73A]/g}, {'base': 'AY', 'letters': /[\uA73C]/g}, {'base': 'B', 'letters': /[\u0042\u24B7\uFF22\u1E02\u1E04\u1E06\u0243\u0182\u0181]/g}, {'base': 'C', 'letters': /[\u0043\u24B8\uFF23\u0106\u0108\u010A\u010C\u00C7\u1E08\u0187\u023B\uA73E]/g}, {'base': 'D', 'letters': /[\u0044\u24B9\uFF24\u1E0A\u010E\u1E0C\u1E10\u1E12\u1E0E\u0110\u018B\u018A\u0189\uA779]/g}, {'base': 'DZ', 'letters': /[\u01F1\u01C4]/g}, {'base': 'Dz', 'letters': /[\u01F2\u01C5]/g}, {'base': 'E', 'letters': /[\u0045\u24BA\uFF25\u00C8\u00C9\u00CA\u1EC0\u1EBE\u1EC4\u1EC2\u1EBC\u0112\u1E14\u1E16\u0114\u0116\u00CB\u1EBA\u011A\u0204\u0206\u1EB8\u1EC6\u0228\u1E1C\u0118\u1E18\u1E1A\u0190\u018E]/g}, {'base': 'F', 'letters': /[\u0046\u24BB\uFF26\u1E1E\u0191\uA77B]/g}, {'base': 'G', 'letters': /[\u0047\u24BC\uFF27\u01F4\u011C\u1E20\u011E\u0120\u01E6\u0122\u01E4\u0193\uA7A0\uA77D\uA77E]/g}, {'base': 'H', 'letters': /[\u0048\u24BD\uFF28\u0124\u1E22\u1E26\u021E\u1E24\u1E28\u1E2A\u0126\u2C67\u2C75\uA78D]/g}, {'base': 'I', 'letters': /[\u0049\u24BE\uFF29\u00CC\u00CD\u00CE\u0128\u012A\u012C\u0130\u00CF\u1E2E\u1EC8\u01CF\u0208\u020A\u1ECA\u012E\u1E2C\u0197]/g}, {'base': 'J', 'letters': /[\u004A\u24BF\uFF2A\u0134\u0248]/g}, {'base': 'K', 'letters': /[\u004B\u24C0\uFF2B\u1E30\u01E8\u1E32\u0136\u1E34\u0198\u2C69\uA740\uA742\uA744\uA7A2]/g}, {'base': 'L', 'letters': /[\u004C\u24C1\uFF2C\u013F\u0139\u013D\u1E36\u1E38\u013B\u1E3C\u1E3A\u0141\u023D\u2C62\u2C60\uA748\uA746\uA780]/g}, {'base': 'LJ', 'letters': /[\u01C7]/g}, {'base': 'Lj', 'letters': /[\u01C8]/g}, {'base': 'M', 'letters': /[\u004D\u24C2\uFF2D\u1E3E\u1E40\u1E42\u2C6E\u019C]/g}, {'base': 'N', 'letters': /[\u004E\u24C3\uFF2E\u01F8\u0143\u00D1\u1E44\u0147\u1E46\u0145\u1E4A\u1E48\u0220\u019D\uA790\uA7A4]/g}, {'base': 'NJ', 'letters': /[\u01CA]/g}, {'base': 'Nj', 'letters': /[\u01CB]/g}, {'base': 'O', 'letters': /[\u004F\u24C4\uFF2F\u00D2\u00D3\u00D4\u1ED2\u1ED0\u1ED6\u1ED4\u00D5\u1E4C\u022C\u1E4E\u014C\u1E50\u1E52\u014E\u022E\u0230\u00D6\u022A\u1ECE\u0150\u01D1\u020C\u020E\u01A0\u1EDC\u1EDA\u1EE0\u1EDE\u1EE2\u1ECC\u1ED8\u01EA\u01EC\u00D8\u01FE\u0186\u019F\uA74A\uA74C]/g}, {'base': 'OI', 'letters': /[\u01A2]/g}, {'base': 'OO', 'letters': /[\uA74E]/g}, {'base': 'OU', 'letters': /[\u0222]/g}, {'base': 'P', 'letters': /[\u0050\u24C5\uFF30\u1E54\u1E56\u01A4\u2C63\uA750\uA752\uA754]/g}, {'base': 'Q', 'letters': /[\u0051\u24C6\uFF31\uA756\uA758\u024A]/g}, {'base': 'R', 'letters': /[\u0052\u24C7\uFF32\u0154\u1E58\u0158\u0210\u0212\u1E5A\u1E5C\u0156\u1E5E\u024C\u2C64\uA75A\uA7A6\uA782]/g}, {'base': 'S', 'letters': /[\u0053\u24C8\uFF33\u1E9E\u015A\u1E64\u015C\u1E60\u0160\u1E66\u1E62\u1E68\u0218\u015E\u2C7E\uA7A8\uA784]/g}, {'base': 'T', 'letters': /[\u0054\u24C9\uFF34\u1E6A\u0164\u1E6C\u021A\u0162\u1E70\u1E6E\u0166\u01AC\u01AE\u023E\uA786]/g}, {'base': 'TZ', 'letters': /[\uA728]/g}, {'base': 'U', 'letters': /[\u0055\u24CA\uFF35\u00D9\u00DA\u00DB\u0168\u1E78\u016A\u1E7A\u016C\u00DC\u01DB\u01D7\u01D5\u01D9\u1EE6\u016E\u0170\u01D3\u0214\u0216\u01AF\u1EEA\u1EE8\u1EEE\u1EEC\u1EF0\u1EE4\u1E72\u0172\u1E76\u1E74\u0244]/g}, {'base': 'V', 'letters': /[\u0056\u24CB\uFF36\u1E7C\u1E7E\u01B2\uA75E\u0245]/g}, {'base': 'VY', 'letters': /[\uA760]/g}, {'base': 'W', 'letters': /[\u0057\u24CC\uFF37\u1E80\u1E82\u0174\u1E86\u1E84\u1E88\u2C72]/g}, {'base': 'X', 'letters': /[\u0058\u24CD\uFF38\u1E8A\u1E8C]/g}, {'base': 'Y', 'letters': /[\u0059\u24CE\uFF39\u1EF2\u00DD\u0176\u1EF8\u0232\u1E8E\u0178\u1EF6\u1EF4\u01B3\u024E\u1EFE]/g}, {'base': 'Z', 'letters': /[\u005A\u24CF\uFF3A\u0179\u1E90\u017B\u017D\u1E92\u1E94\u01B5\u0224\u2C7F\u2C6B\uA762]/g}, {'base': 'a', 'letters': /[\u0061\u24D0\uFF41\u1E9A\u00E0\u00E1\u00E2\u1EA7\u1EA5\u1EAB\u1EA9\u00E3\u0101\u0103\u1EB1\u1EAF\u1EB5\u1EB3\u0227\u01E1\u00E4\u01DF\u1EA3\u00E5\u01FB\u01CE\u0201\u0203\u1EA1\u1EAD\u1EB7\u1E01\u0105\u2C65\u0250]/g}, {'base': 'aa', 'letters': /[\uA733]/g}, {'base': 'ae', 'letters': /[\u00E6\u01FD\u01E3]/g}, {'base': 'ao', 'letters': /[\uA735]/g}, {'base': 'au', 'letters': /[\uA737]/g}, {'base': 'av', 'letters': /[\uA739\uA73B]/g}, {'base': 'ay', 'letters': /[\uA73D]/g}, {'base': 'b', 'letters': /[\u0062\u24D1\uFF42\u1E03\u1E05\u1E07\u0180\u0183\u0253]/g}, {'base': 'c', 'letters': /[\u0063\u24D2\uFF43\u0107\u0109\u010B\u010D\u00E7\u1E09\u0188\u023C\uA73F\u2184]/g}, {'base': 'd', 'letters': /[\u0064\u24D3\uFF44\u1E0B\u010F\u1E0D\u1E11\u1E13\u1E0F\u0111\u018C\u0256\u0257\uA77A]/g}, {'base': 'dz', 'letters': /[\u01F3\u01C6]/g}, {'base': 'e', 'letters': /[\u0065\u24D4\uFF45\u00E8\u00E9\u00EA\u1EC1\u1EBF\u1EC5\u1EC3\u1EBD\u0113\u1E15\u1E17\u0115\u0117\u00EB\u1EBB\u011B\u0205\u0207\u1EB9\u1EC7\u0229\u1E1D\u0119\u1E19\u1E1B\u0247\u025B\u01DD]/g}, {'base': 'f', 'letters': /[\u0066\u24D5\uFF46\u1E1F\u0192\uA77C]/g}, {'base': 'g', 'letters': /[\u0067\u24D6\uFF47\u01F5\u011D\u1E21\u011F\u0121\u01E7\u0123\u01E5\u0260\uA7A1\u1D79\uA77F]/g}, {'base': 'h', 'letters': /[\u0068\u24D7\uFF48\u0125\u1E23\u1E27\u021F\u1E25\u1E29\u1E2B\u1E96\u0127\u2C68\u2C76\u0265]/g}, {'base': 'hv', 'letters': /[\u0195]/g}, {'base': 'i', 'letters': /[\u0069\u24D8\uFF49\u00EC\u00ED\u00EE\u0129\u012B\u012D\u00EF\u1E2F\u1EC9\u01D0\u0209\u020B\u1ECB\u012F\u1E2D\u0268\u0131]/g}, {'base': 'j', 'letters': /[\u006A\u24D9\uFF4A\u0135\u01F0\u0249]/g}, {'base': 'k', 'letters': /[\u006B\u24DA\uFF4B\u1E31\u01E9\u1E33\u0137\u1E35\u0199\u2C6A\uA741\uA743\uA745\uA7A3]/g}, {'base': 'l', 'letters': /[\u006C\u24DB\uFF4C\u0140\u013A\u013E\u1E37\u1E39\u013C\u1E3D\u1E3B\u017F\u0142\u019A\u026B\u2C61\uA749\uA781\uA747]/g}, {'base': 'lj', 'letters': /[\u01C9]/g}, {'base': 'm', 'letters': /[\u006D\u24DC\uFF4D\u1E3F\u1E41\u1E43\u0271\u026F]/g}, {'base': 'n', 'letters': /[\u006E\u24DD\uFF4E\u01F9\u0144\u00F1\u1E45\u0148\u1E47\u0146\u1E4B\u1E49\u019E\u0272\u0149\uA791\uA7A5]/g}, {'base': 'nj', 'letters': /[\u01CC]/g}, {'base': 'o', 'letters': /[\u006F\u24DE\uFF4F\u00F2\u00F3\u00F4\u1ED3\u1ED1\u1ED7\u1ED5\u00F5\u1E4D\u022D\u1E4F\u014D\u1E51\u1E53\u014F\u022F\u0231\u00F6\u022B\u1ECF\u0151\u01D2\u020D\u020F\u01A1\u1EDD\u1EDB\u1EE1\u1EDF\u1EE3\u1ECD\u1ED9\u01EB\u01ED\u00F8\u01FF\u0254\uA74B\uA74D\u0275]/g}, {'base': 'oi', 'letters': /[\u01A3]/g}, {'base': 'ou', 'letters': /[\u0223]/g}, {'base': 'oo', 'letters': /[\uA74F]/g}, {'base': 'p', 'letters': /[\u0070\u24DF\uFF50\u1E55\u1E57\u01A5\u1D7D\uA751\uA753\uA755]/g}, {'base': 'q', 'letters': /[\u0071\u24E0\uFF51\u024B\uA757\uA759]/g}, {'base': 'r', 'letters': /[\u0072\u24E1\uFF52\u0155\u1E59\u0159\u0211\u0213\u1E5B\u1E5D\u0157\u1E5F\u024D\u027D\uA75B\uA7A7\uA783]/g}, {'base': 's', 'letters': /[\u0073\u24E2\uFF53\u00DF\u015B\u1E65\u015D\u1E61\u0161\u1E67\u1E63\u1E69\u0219\u015F\u023F\uA7A9\uA785\u1E9B]/g}, {'base': 't', 'letters': /[\u0074\u24E3\uFF54\u1E6B\u1E97\u0165\u1E6D\u021B\u0163\u1E71\u1E6F\u0167\u01AD\u0288\u2C66\uA787]/g}, {'base': 'tz', 'letters': /[\uA729]/g}, {'base': 'u', 'letters': /[\u0075\u24E4\uFF55\u00F9\u00FA\u00FB\u0169\u1E79\u016B\u1E7B\u016D\u00FC\u01DC\u01D8\u01D6\u01DA\u1EE7\u016F\u0171\u01D4\u0215\u0217\u01B0\u1EEB\u1EE9\u1EEF\u1EED\u1EF1\u1EE5\u1E73\u0173\u1E77\u1E75\u0289]/g}, {'base': 'v', 'letters': /[\u0076\u24E5\uFF56\u1E7D\u1E7F\u028B\uA75F\u028C]/g}, {'base': 'vy', 'letters': /[\uA761]/g}, {'base': 'w', 'letters': /[\u0077\u24E6\uFF57\u1E81\u1E83\u0175\u1E87\u1E85\u1E98\u1E89\u2C73]/g}, {'base': 'x', 'letters': /[\u0078\u24E7\uFF58\u1E8B\u1E8D]/g}, {'base': 'y', 'letters': /[\u0079\u24E8\uFF59\u1EF3\u00FD\u0177\u1EF9\u0233\u1E8F\u00FF\u1EF7\u1E99\u1EF5\u01B4\u024F\u1EFF]/g}, {'base': 'z', 'letters': /[\u007A\u24E9\uFF5A\u017A\u1E91\u017C\u017E\u1E93\u1E95\u01B6\u0225\u0240\u2C6C\uA763]/g}];

        var changes;

        return (function(str) {
            if(!changes) {
                changes = defaultDiacriticsRemovalMap;
            }
            for(var i = 0; i<changes.length; i++) {
                str = str.replace(changes[i].letters, changes[i].base);
            }
            return str;
        })(str);
    }, getID: function(id) {
        return document.getElementById(id);
    }, resizePopup: function() {
        var $body = $("body");

        $body.css("height", "");

        if($(".popover").length) $body.css("height", $body.prop("scrollHeight"));
    }, ex: function(id) {
        return $(oib.getID(id));
    }, escapeRegExp: function(str) {
        return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
    }, tasksSelectorTooltip: function() {
        var tasksList = "";

        var TasksSelectorTooltip = {
            init: function(tasksListId, callback) {
                $.getJSON(oib.baseDomain + "pages/ajax/tasks.php", {start: 0, length: -1, search: "start-All-all-2-"}, function(response) {
                    popovers.push(oib.ex(tasksListId).popover({
                        html: true, placement: 'bottom', backdrop: false, trigger: 'click', title: "Pick task<button class=\"btn btn-small btn--green pull-right\" data-ui=\"create-task\"><i class=\"fa fa-plus\"></i></button>", content: function() {
                            var self = $(this).data("bs.popover");

                            var head = "<div><input placeholder=\"Search tasks...\" class=\"_14ei\"><div class=\"_22rd\">", html = head;
                            $.each(response.data, function(_, task) {
                                html += "<div class=\"_22re\" data-hash=\"" + task.ID + "\">" + task.NAME + "<div class=\"_22rg\"><i class=\"fa fa-arrow-right\"></i></div></div>";
                            });
                            html += "</div></div>";

                            html = $(html);

                            html.find("._22re").click(function() {
                                var taskHash = $(this).data("hash");

                                var text = $(this).text();

                                if(typeof callback === "function") callback(text, taskHash, "TASK");

                                self.$element.html(text);

                                oib.ex(tasksListId).popover("hide");
                            });

                            function bindSearch(html) {
                                html.find("input").off("keyup").on("keyup", function() {
                                    var searchText = this.value;
                                    console.log(html.find("._22re:not(._22rx)"));
                                    html.find("._22re:not(._22rx)").each(function() {
                                        var item = $(this);
                                        if(!searchText || new RegExp(oib.escapeRegExp(oib.removeDiacritics(searchText)), "i").test(oib.removeDiacritics(item[0].textContent))) {
                                            item.removeClass("hidden");
                                        } else {
                                            item.addClass("hidden");
                                        }
                                    });
                                });
                            }

                            bindSearch(html);
                            if(!tasksList) tasksList = html;
                            return html;
                        }
                    }).on('shown.bs.popover', function () {
                        oib.resizePopup();
                    }).on('hidden.bs.popover', function () {
                        oib.resizePopup();
                    }));

                    $(document).off("click", "[data-ui=create-task]").on("click", "[data-ui=create-task]", function() {
                        oib.loadPage("new-task");
                    });
                });
            }, reset: function() {
                oib.ex(TasksSelectorTooltip.$tasksListId).html("Select <span class=\"underlined\">task</span> from list");
                oib.ex(TasksSelectorTooltip.$taskInputId).val("");
            }, draw: function(tasksListId, taskInputId, className) {
                if(!className) className = "";
                TasksSelectorTooltip.$tasksListId = tasksListId;
                TasksSelectorTooltip.$taskInputId = taskInputId;

                return "<div class=\"clearfix" + (className && " " + className) + "\"><div><a class=\"fcg\" id=\"" + tasksListId + "\">Select <span class=\"underlined\">task</span> from list</a></div><input type=\"hidden\" id=\"" + taskInputId + "\"></div>";
            }, $tasksListId: null, $taskInputId: null
        };

        return TasksSelectorTooltip;
    }, transactionSelectorTooltip: function() {
        var transactionText, serviceText, providerText, workTableList = [], transactionId, serviceId, providerId;

        var TransactionSelectorTooltip = {
            init: function(workTableListId, transactionInputId, serviceInputId, providerInputId, callback) {
                $.getJSON(oib.baseDomain + "pages/ajax/transaction_live.php", {tree: "-1"}, function(response) {
                    workTableList = response;
                    popovers.push(oib.ex(workTableListId).popover({
                        html: true, placement: 'bottom', backdrop: false, trigger: 'click', title: "Pick transaction"+((TransactionSelectorTooltip.onlyTransaction) ? "" : " (1/3)"), content: function() {
                            var self = $(this).data("bs.popover"), transactionsList, servicesList;

                            var head = "<div><input placeholder=\"Search...\" class=\"_14ei\"><div class=\"_22rd\">", html = head;
                            $.each(workTableList, function(_, transaction) {
                                html += "<div class=\"_22re\" data-id=\"" + transaction._ID + "\" data-hash=\"" + transaction.ID + "\">" + transaction.NAME + "<div class=\"_22rg\"><i class=\"fa fa-arrow-right\"></i></div></div>";
                            });
                            html += "</div></div>";

                            html = $(html);

                            function transactionHead() {
                                self.$tip.find(".popover-title").html("<div class=\"_22ra\"><i class=\"fa fa-arrow-left\"></i></div> Pick service (2/3)").find("._22ra").click(function(event) {
                                    event.preventDefault();
                                    self.$tip.find(".popover-title").html("Pick transaction (1/3)");
                                    self.$tip.find(".popover-content").html(transactionsList);
                                    servicesList = "";
                                    bindServices(transactionsList);
                                    bindSearch(transactionsList);
                                    return false;
                                });
                            }

                            function bindSearch(html) {
                                html.find("input").off("keyup").on("keyup", function() {
                                    var searchText = this.value;
                                    console.log(html.find("._22re:not(._22rx)"));
                                    html.find("._22re:not(._22rx)").each(function() {
                                        var item = $(this);
                                        if(!searchText || new RegExp(oib.escapeRegExp(oib.removeDiacritics(searchText)), "i").test(oib.removeDiacritics(item[0].textContent))) {
                                            item.removeClass("hidden");
                                        } else {
                                            item.addClass("hidden");
                                        }
                                    });
                                });
                            }

                            function bindProvider(html) {
                                html.find("._22re:not(._22rx)").click(function() {
                                    serviceText = $(this).text();
                                    serviceId = $(this).data("id");
                                    self.$tip.find(".popover-title").html("<div class=\"_22ra\"><i class=\"fa fa-arrow-left\"></i></div> Pick workdesk (3/3)").find("._22ra").click(function(event) {
                                        event.preventDefault();
                                        transactionHead();
                                        self.$tip.find(".popover-content").html(servicesList);
                                        bindProvider(servicesList);
                                        bindSearch(servicesList);
                                        return false;
                                    });


                                    html = head;

                                    $.getJSON(oib.baseDomain + "pages/ajax/expense.php", {ets: $(this).data("id")}, function(response) {
                                        $.each(response, function(_, provider) {
                                            html += "<div class=\"_22re\" data-id=\"" + provider.ID + "\" data-wt-id=\"" + provider.WT_ID + "\" data-wt-hash=\"" + provider.WT_HASH + "\" data-provider-name=\"" + provider.NAME + "\" data-workdesk=\"" + provider.WT_NAME + "\"><img alt=\"image\" src=\"" + provider.AVATAR + "\" class=\"pull-left m-r-sm\"><div class=\"pull-left\">" + provider.NAME + ((provider.WT_NAME) ? "<br><small>" + provider.WT_NAME + "</small>" : "") + "</div><div class=\"_22rg\"><i class=\"fa fa-arrow-right\"></i></div></div>";
                                        });
                                        html += "</div></div>";
                                        html = $(html);

                                        html.find("._22re").click(function() {
                                            var workdeskText = $(this).data("workdesk");

                                            providerText = $(this).data("provider-name");
                                            if(workdeskText) providerText += " (" + workdeskText + ")";
                                            providerId = $(this).data("wt-hash");

                                            oib.ex(transactionInputId).val(transactionId);
                                            oib.ex(serviceInputId).val(serviceId);
                                            oib.ex(providerInputId).val(providerId);

                                            var text = transactionText + " &rarr; " + serviceText + " &rarr; " + providerText;

                                            if(typeof callback === "function") callback(text, providerId, "WORK_TABLE");

                                            $("[data-ui=picked-workdesk-text]").html(text);
                                            $("[data-ui=global-workdesk-selector]").hide();

                                            oib.ex(workTableListId).popover("hide");
                                        });

                                        self.$tip.find(".popover-content").html(html);
                                        bindSearch(html);
                                    });
                                });
                            }

                            function bindServices(html) {
                                html.find("._22re").click(function() {
                                    transactionText = $(this).text();
                                    transactionId = $(this).data("id");
                                    transactionHead();

                                    if(!TransactionSelectorTooltip.onlyTransaction) {
                                        html = head;

                                        $.getJSON(oib.baseDomain + "pages/ajax/services.php", {transaction: $(this).data("hash")}, function(response) {
                                            for(var i = 0; i<response.length; i++) {
                                                var stream = response[i];
                                                html += "<div class=\"_22re _22rx\"><i class=\"fa fa-briefcase\"></i> " + stream.NAME + "</div>";
                                                for(var m = 0; m<stream.MILESTONES.length; m++) {
                                                    var mile = stream.MILESTONES[m];
                                                    html += "<div class=\"_22re _22rx _22rz\"><i class=\"fa fa-bookmark\"></i> " + mile.NAME + "</div>";
                                                    for(var s = 0; s<mile.SERVICES.length; s++) {
                                                        var service = mile.SERVICES[s];
                                                        html += "<div class=\"_22re _22ry\" data-id=\"" + service.ID + "\">" + service.NAME + "<div class=\"_22rg\"><i class=\"fa fa-arrow-right\"></i></div></div>";
                                                    }
                                                }
                                            }
                                            html += "</div></div>";
                                            html = $(html);
                                            servicesList = html;
                                            self.$tip.find(".popover-content").html(html);

                                            bindProvider(html);
                                            bindSearch(html);
                                        });
                                    } else {
                                        if(typeof callback === "function") callback(transactionText, transactionId, "TRANSACTION");

                                        $("[data-ui=picked-workdesk-text]").html(transactionText);
                                        $("[data-ui=global-workdesk-selector]").hide();
                                        oib.ex(workTableListId).popover("hide");
                                    }
                                });
                            }

                            bindServices(html);
                            bindSearch(html);
                            if(!transactionsList) transactionsList = html;
                            return html;
                        }
                    }).on('shown.bs.popover', function () {
                        oib.resizePopup();
                    }).on('hidden.bs.popover', function () {
                        oib.resizePopup();
                    }));
                });
            }, reset: function() {
                oib.ex(TransactionSelectorTooltip.$workTableListId).html(((TransactionSelectorTooltip.onlyTransaction) ? "transaction" : "workdesk"));
                oib.ex(TransactionSelectorTooltip.$serviceInputId).val("");
                oib.ex(TransactionSelectorTooltip.$transactionInputId).val("");
                oib.ex(TransactionSelectorTooltip.$providerInputId).val("");
                $("[data-ui=global-workdesk-selector]").show();
                $("[data-ui=picked-workdesk-text]").html("");
            }, draw: function(workTableListId, transactionInputId, serviceInputId, providerInputId, className, onlyTransaction) {
                if(!className) className = "";
                TransactionSelectorTooltip.onlyTransaction = onlyTransaction;
                TransactionSelectorTooltip.$workTableListId = workTableListId;
                TransactionSelectorTooltip.$transactionInputId = transactionInputId;
                TransactionSelectorTooltip.$serviceInputId = serviceInputId;
                TransactionSelectorTooltip.$providerInputId = providerInputId;

                return "<div class=\"clearfix" + (className && " " + className) + "\"><div><a class=\"fcg\" id=\"" + workTableListId + "\">"+((TransactionSelectorTooltip.onlyTransaction) ? "transaction" : "workdesk")+"</a></div><input type=\"hidden\" id=\"" + transactionInputId + "\"><input type=\"hidden\" id=\"" + serviceInputId + "\"><input type=\"hidden\" id=\"" + providerInputId + "\"></div>";
            }, convertToText: function(scheme, full) {
                var parts = [];
                $.each(scheme, function(_, data) {
                    if(full || (_ === "transaction" || _ === "service" || _ === "provider")) parts.push(data.name);
                });

                if(parts.length) return parts.join(" &rarr; ");
                return ((TransactionSelectorTooltip.onlyTransaction) ? "transaction" : "workdesk");
            }, pushData: function(scheme) {
                oib.ex(TransactionSelectorTooltip.$workTableListId).html(TransactionSelectorTooltip.convertToText(scheme));
                oib.ex(TransactionSelectorTooltip.$serviceInputId).val(scheme.service.id);
                oib.ex(TransactionSelectorTooltip.$transactionInputId).val(scheme.transaction.id);
                oib.ex(TransactionSelectorTooltip.$providerInputId).val(scheme.provider.hash);
            }, onlyTransaction: false, $workTableListId: null, $transactionInputId: null, $serviceInputId: null, $providerInputId: null
        };

        return TransactionSelectorTooltip;
    }, init: function() {
        if(!oib.isLogged()) {
            oib.loadPage("home");
        } else {
            oib.loadPage("bookmark");
        }

        oib.checkLogin();

        getCurrentTabUrl(function(tab) {
            var origin = new URL(tab.url);
            if(!oib.isLogged()) {
                if(origin.hostname.indexOf("o-i-b.com")>=0 || origin.hostname.indexOf("ops-in-a-box")>=0) {
                    oib.loginInterval = setInterval(function() {
                        oib.checkLogin();
                        if(oib.isLogged()) {
                            clearInterval(oib.loginInterval);
                        }
                    }, 5000);
                } else {
                    clearInterval(oib.loginInterval);
                }
            }
        });


    }, setLogged: function(a) {
        localStorage.setItem("logged", a);
        return this;
    }, isLogged: function() {
        return localStorage.getItem("logged");
    }, sessionInterval: "", loginInterval: "", checkLogin: function() {
        $.ajax({
            url: oib.baseDomain + "api/user/session", method: "POST", success: function(json) {
                oib.setLoggedUser(json.data.user.UserHash);

                if(json.data.user.UserHash!==null&&json.data.user.UserHash.length>0) {
                    oib.loadPage("bookmark");
                    oib.setLogged(true);
                } else {
                    oib.loadPage("home");
                    oib.setLogged(false);
                }
            }
        });
    }, loadPage: function(page) {
        oib.setPage(page);
        var self = this;
        document.body.id = "oib-" + page;
        var container = $(".container"), html;
        switch(page) {
            case "home":
                html = $('<section class="text-center muted"><div class="wrapper-m"><img src="logoProfitCircles.png" width="180px"><h1 class="mt-m mb-xl">Run Your Business Simply</h1><p><button class="btn btn--gray" data-ui="signup-btn">Sign up</button></p></div><div class="or-separator"><span>or</span></div><p class="mb-m">Already have a OIB Account?<span class="simple-link ml-xs" data-ui="sign-in">Sign in</span></p></section>');
                html.find("[data-ui=sign-in]").on("click", function() {
                    var win = window.open(self.baseDomain + "?page=login&action=register", '_blank');
                    win.focus();
                });
                html.find("[data-ui=signup-btn]").on("click", function() {
                    var win = window.open(self.baseDomain + "/?page=login", '_blank');
                    win.focus();
                });
                container.html(html);
                break;
            case "bookmark":
                var workTableListId = oib.uniqueID();
                var transactionListId = oib.uniqueID();
                var tasksListId = oib.uniqueID();

                var transactionInputId = oib.uniqueID();
                var serviceInputId = oib.uniqueID();
                var providerInputId = oib.uniqueID();

                var taskInputId = oib.uniqueID();

                var html = $('<header class="header" role="banner"><img src="icon.png" width="25px"><nav class="nav" role="navigation"><ul><li data-ui="close-btn"><svg><use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#close"></use></svg></li></ul></nav></header><div class="main"><div class="scroll"><section class="settings section"><div class="flag"><div class="flag__section"><h2 class="section__title mt-s">CURRENT SESSION</h2></div><div class="flag__section"><button data-ui="bookmark-btn" class="btn btn--gray pull-right">BOOKMARKED</button></div></div><div class="flag _3re"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-thumb-tack"></i> Target</label><div class="flag__section"><div data-ui="picked-workdesk-text"></div><div data-ui="global-workdesk-selector">Select <p data-ui="workdesk-selector" class="inline undeline"></p> or <p data-ui="transaction-selector" class="inline undeline"></p> from list</div></div></div><div class="flag"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-tasks"></i> Task</label><div class="flag__section"><p data-ui="task-selector"></p></div></div><div class="flag"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-tags"></i> Tags</label><div class="flag__section"><div data-ui="account-selector"><select class="form-control" data-ui="tags" multiple></select></div></div></div><!-- <div class="flag"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-bell"></i> Tags</label><div class="flag__section"><div data-ui="account-selector">Select Tags...</div></div></div> --><div class="flag"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-bars"></i> Title</label><div class="flag__section"><div data-ui="account-selector"><input type="text" value="' + oib.getCurrentSessionTitle() + '" data-ui="title" class="underlined"></div></div></div><div class="flag"><label class="flag__section flag__section--nowrap faded"><i class="fa fa-link"></i> URL</label><div class="flag__section"><div data-ui="account-selector">' + oib.getCurrentSession() + '</div></div></div></section><div></div></div></div>');

                var transactionSelectorTooltip = oib.transactionSelectorTooltip();

                var transactionSelectorTooltip2 = oib.transactionSelectorTooltip();

                html.find("[data-ui=workdesk-selector]").html(transactionSelectorTooltip.draw(workTableListId, transactionInputId, serviceInputId, providerInputId));

                html.find("[data-ui=transaction-selector]").html(transactionSelectorTooltip2.draw(transactionListId, transactionInputId, serviceInputId, providerInputId, null, true));

                var tasksSelectorTooltip = oib.tasksSelectorTooltip();

                html.find("[data-ui=task-selector]").html(tasksSelectorTooltip.draw(tasksListId, taskInputId));

                var typeTimeout;


                html.find("[data-ui=tags]").tokenize2({
                    dataSource: oib.baseDomain+"api/tags/autocomplete/list", searchMinLength: 1,
                    placeholder: "Search for tags..."
                });

                html.find("[data-ui=title]").on("keypress keydown", function() {
                    if(typeTimeout) clearTimeout(typeTimeout);

                    var self = this;

                    setTimeout(function() {
                        oib.setCurrentSessionTitle(self.value).setModifiedTitle(true);
                    }, 800);
                });

                var errorCallback = function(error) {
                    bookmark.html("SAVING...").addClass("btn--green").removeClass("btn--gray btn--red");

                    setTimeout(function() {
                        if(error.code === 2) {
                            bookmark.html("ALREADY SAVED <i class=\"fa fa-bookmark\"></i>").addClass("btn--green").removeClass("btn--gray btn--red");
                        } else {
                            bookmark.html("RETRY <i class=\"fa fa-repeat\"></i>").addClass("btn--red").removeClass("btn--gray");
                        }

                        bookmark.attr("disabled", false);
                    }, 1000);
                };

                var saveCallback = function(text, objectHash, type) {
                    if(type === "WORK_TABLE" || type === "TRANSACTION") {
                        tasksSelectorTooltip.reset();
                    } else {
                        transactionSelectorTooltip.reset();
                        transactionSelectorTooltip2.reset();
                    }

                    self.save = false;

                    bookmark.html("BOOKMARK <i class=\"fa fa-bookmark\"></i>").addClass("btn--green").removeClass("btn--gray btn--red").off("click.bookmark").on("click.bookmark", function() {
                        if(self.save || bookmark.hasClass("btn--gray")) return;
                        bookmark.attr("disabled", true);
                        self.save = true;

                        var data = {
                            link: self.getCurrentSession(), filename: self.getCurrentSessionTitle(), check: "duplicity", tags: html.find("[data-ui=tags]").data('tokenize2').toArray()
                        };

                        if(type === "WORK_TABLE") {
                            data.tableHash = objectHash;
                        } else if(type === "TRANSACTION") {
                            data.transactionId = objectHash;
                        } else {
                            data.taskHash = objectHash;
                        }

                        $.ajax({
                            url: self.baseDomain + "api/file/create", data: data, method: "POST", error: function() {
                                errorCallback({});
                            }, success: function(json) {
                                self.save = false;
                                bookmark.attr("disabled", false);

                                if("error" in json) {
                                    errorCallback(json.error);
                                } else {
                                    oib.setModifiedTitle(false);
                                    bookmark.html("BOOKMARKED <i class=\"fa fa-check\"></i>").addClass("btn--gray").removeClass("btn--green");
                                }
                            }
                        });
                    });
                };

                tasksSelectorTooltip.init(tasksListId, saveCallback);

                transactionSelectorTooltip.init(workTableListId, transactionInputId, serviceInputId, providerInputId, saveCallback);
                transactionSelectorTooltip2.init(transactionListId, transactionInputId, serviceInputId, providerInputId, saveCallback);

                var bookmark = html.find("[data-ui=bookmark-btn]");

                bookmark.html("BOOKMARK <i class=\"fa fa-bookmark\"></i>").addClass("btn--gray").removeClass("btn--green");

                container.html(html);

                $("body").on("click", function(e) {
                    $.each(popovers, function() {
                        if(!$(this).is(e.target) && $(this).has(e.target).length === 0 && $('.popover').has(e.target).length === 0) {
                            $(this).popover('hide');
                        }
                    });
                });

                break;

            case "new-task":
                chrome.tabs.create({url: oib.baseDomain+"tasks/new?ref=extension&_data="+encodeURI(btoa(unescape(encodeURIComponent(JSON.stringify({title:oib.getCurrentSessionTitle(), uri: oib.getCurrentSession()}))))), active: true});
            break;
        }
        container.find("[data-ui=close-btn]").on("click", function() {
            window.close();
        });
    }
};

document.addEventListener('DOMContentLoaded', function() {
    getCurrentTabUrl(function(tab) {
        oib.setCurrentSession(tab.url);
        if(!oib.isModifiedTitle() || oib.getLastSession() && (oib.getCurrentSession() !== oib.getLastSession()) || !oib.getCurrentSessionTitle()) oib.setModifiedTitle(false).setCurrentSessionTitle(tab.title);
        oib.setLastSession(oib.getCurrentSession());

        oib.init();
    });
});
